#!/bin/sh

GPS_NIST_FILE="/tmp/gps_nist.txt"
GPS_NIST_FILE_COPY="/tmp/gps_nist.copy"
NTP_NIST_FILE="/etc/ntp_leap_file.list"

ntpd_restart()
{
  echo "restarting NTPD"
  /etc/init.d/ntpd restart
}

cmp -s /tmp/gps_nist.txt /etc/ntp_leap_file.list
# 1 if we have to restart NTPD
needNtpdRestart=0
# pid of NTPD process
ntpdPid=`cat /var/run/ntpd.pid`
# name of gps0 pts file 
gps0RealFileName=`ls -l /dev/gps0 | awk '{print $11}'`
# boolean telling if gps file is openened by ntp process
gpsFileNotOpened=1

if [ "x${ntpdPid}" != "x" -a "x${gps0RealFileName}" != "x" ]
then
  ls -l /proc/${ntpdPid}/fd | grep ${gps0RealFileName} | grep -v deleted > /dev/null
  gpsFileNotOpened=$?
else
  gpsFileNotOpened=1
fi

if [ -f ${GPS_NIST_FILE} ]
then
  cmp -s ${GPS_NIST_FILE} ${GPS_NIST_FILE_COPY}
  if [ "x$?" != "x0" ]
  then
    # GPS nist file exist and is different from copy, recreate NTP NIST file
    /usr/local/bin/taiclock -p ${GPS_NIST_FILE},${NTP_NIST_FILE}
    cp ${GPS_NIST_FILE} ${GPS_NIST_FILE_COPY}
    echo "NIST file rebuilt"
    needNtpdRestart=1
  fi
fi

if [ "x${needNtpdRestart}" = "x1" -o "x${gpsFileNotOpened}" != "x0" ]
then
  ntpd_restart
fi
